%define name webalizer
%define mVersion 2.01
%define lVersion 10
%define release 15mdk
%define summary Web server log file analysis thingie
%define lang catalan chinese croatian czech danish dutch estonian finnish french galician german greek hungarian icelandic indonesian italian japanese korean latvian malay norwegian polish portuguese portuguese_brazil romanian russian serbian simplified_chinese slovak slovene spanish swedish turkish ukrainian
%define locales ca zh hr cs da nl et fi fr gl de el hu is id it ja ko lv ms no pl pt pt ro ru sr zh sk sl es sv tr uk

Name: %{name}
Version: %{mVersion}.%{lVersion}
Release: %{release}
Summary: %{summary}
URL: http://www.mrunix.net/webalizer/
Source0: %{name}-%{mVersion}-%{lVersion}-src.tar.bz2
Source1: %{name}-generate-lang.perl
Source2: %{name}.cron.bz2
Source3: track_hist.bz2
Source4: README-FIRST.bz2

# http://www.isthe.com/chongo/src/webalizer-patch/
Patch0: webalizer-2.01.10-0.basic.patch.bz2
Patch1: webalizer-2.01.10-1.64bit.patch.bz2
Patch2: webalizer-2.01.10-2.hist.patch.bz2
Patch3: webalizer-2.01.10-3.geolizer.patch.bz2

# w3c support
# http://www.ailis.de/~k/software/patches/webalizer-w3c-v4.diff
Patch4: webalizer-w3c-v4.diff.bz2

# mod_logio support
# ftp://ftp.rexursive.com/pub/webalizer/webalizer-in-out.patch.gz
Patch5: webalizer-2.01-10-logio.patch.bz2

# ftp://ftp.mrunix.net/pub/webalizer/contrib/webalizer-2.01-10-UserColor.diff
Patch6: webalizer-2.01-10-UserColor.diff.bz2

Patch7: webalizer-2.01-10-default_config.diff.bz2

License: GPL
Group: Monitoring
BuildRequires: db1-devel
BuildRequires: jpeg-devel
BuildRequires: freetype2-devel
BuildRequires: png-devel
BuildRequires: gd-devel
BuildRequires: perl
BuildRequires: GeoIP-devel
Provides: webalizer-english
BuildRoot: %{_tmppath}/%{name}-buildroot

%description
The Webalizer is a web server log file analysis program which
produces usage statistics in HTML format for viewing with a
browser. The results are presented in both columnar and graphical
format, which facilitates interpretation. Yearly, monthly, daily
and hourly usage statistics are presented, along with the ability
to display usage by site, URL, referrer, user agent (browser) and
country (user agent and referrer are only available if your web
server produces combined log format files).

# Autogenerate language packages from the script defined in Source1:
# It takes multiple calls so that we can keep under the 8k limit
# for the expansion *sigh*
%{expand:%(perl %{SOURCE1} -packages "%lang" "%locales")}
%{expand:%(perl %{SOURCE1} -descriptions "%lang" "%locales")}
%{expand:%(perl %{SOURCE1} -posts "%lang" "%locales")}
%{expand:%(perl %{SOURCE1} -postuns "%lang" "%locales")}
%{expand:%(perl %{SOURCE1} -files "%lang" "%locales")}

%package -n geolizer
Summary: %{summary}
Group: Monitoring
Requires: webalizer

%description -n geolizer
Provides the geolizer binary that enables GeoIP country lookup
using the MaxMind (http://www.maxmind.com/) GeoIP databases.

This package supports English only to reduce the dependencies 
upon the extra GeoIP library.

%prep

%setup -q -n %{name}-%{mVersion}-%{lVersion}
%patch0 -p1 -b .basic
%patch1 -p1 -b .64bit
%patch2 -p1 -b .hist
%patch3 -p1 -b .geolizer
%patch4 -p1 -b .w3c
%patch5 -p1 -b .logio
%patch6 -p1 -b .UserColor
%patch7 -p0 -b .default_config

# fix two bugs
perl -pi -e "s|^#define MAXAGENT.*|#define MAXAGENT 128|g" webalizer.h
perl -pi -e "s|^#define MAXSRCHH.*|#define MAXSRCHH 128|g" webalizer.h

bzcat %{SOURCE3} > track_hist
bzcat %{SOURCE4} > README-FIRST

%build

# first make the geolizer version
%configure \
    --enable-dns \
    --with-db=%{_includedir}/db1 \
    --with-language=english \
    --with-geoip-inc=%{_includedir} \
    --with-geoip-lib=%{_libdir} \
    --enable-geoip
%make
mv webalizer geolizer
make clean

# then make the english version that serves as a "template" for the 
# localization "for" loop below.
%configure \
    --enable-dns \
    --with-db=%{_includedir}/db1 \
    --with-language=english
%make
mv webalizer webalizer-english

# now make some localized versions
for i in %lang; do
echo "########################################################################"
echo "              Building webalizer-${i}"
echo "########################################################################"
ln -snf lang/webalizer_lang.${i} webalizer_lang.h
rm -f *.o
%make
mv webalizer webalizer-${i}
done

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_sysconfdir}/cron.weekly
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_var}/www/html/stats
install -d %{buildroot}%{_mandir}/man1

install -m644 sample.conf %{buildroot}%{_sysconfdir}/webalizer.conf
install -m755 webalizer-* %{buildroot}%{_bindir}/
install -m755 geolizer %{buildroot}%{_bindir}/
install -m755 track_hist %{buildroot}%{_bindir}/
install -m644 webalizer.1 %{buildroot}%{_mandir}/man1/
install -m644 webalizer.png %{buildroot}%{_var}/www/html/stats/
install -m644 msfree.png %{buildroot}%{_var}/www/html/stats/

bzcat %{SOURCE2} > %{buildroot}%{_sysconfdir}/cron.weekly/webalizer
chmod 755 %{buildroot}%{_sysconfdir}/cron.weekly/webalizer

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
update-alternatives --install %{_bindir}/webalizer webalizer %{_bindir}/webalizer-english 100 --slave %{_bindir}/webazolver webazolver %{_bindir}/webalizer-english

%postun
update-alternatives --remove webalizer %{_bindir}/webalizer-english

%files
%defattr(-,root,root)
%doc CHANGES COPYING Copyright DNS.README INSTALL README* country-codes.txt 
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/webalizer.conf
%attr(0755,root,root) %{_sysconfdir}/cron.weekly/webalizer
%attr(0755,root,root) %{_bindir}/webalizer-english
%attr(0755,root,root) %{_bindir}/track_hist
%attr(0644,root,root) %{_mandir}/man1/*
%attr(0644,root,root) %{_var}/www/html/stats/*

%files -n geolizer
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/geolizer

%changelog
* Mon Feb 21 2005 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-15mdk
- added the geolizer patch, rediffed and reordered patches again...

* Sun Feb 20 2005 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-14mdk
- added 64bit patches
- reordered patches
- rediffed new v4 version of the w3 patch to match the 64bit changes
- rediffed the logio patch to match the 64bit changes
- added S3 and S4

* Sun Feb 20 2005 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-13mdk
- double the MAXAGENT and MAXSRCHH size, fixes #12381
- added rediffed P2
- rpmlint fixes
- make some reasonable defaults work...

* Mon Apr 19 2004 Michael Scherer <misc@mandrake.org> 2.01.10-12mdk 
- Birthday rebuild
- Fix Requires and BuildRequires 

* Sun Mar 09 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.01.10-11mdk
- webalizer-japanese requires locales-ja

* Wed Feb 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-10mdk
- fix #1260 this time

* Wed Feb 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-9mdk
- fix #1260 (libgd2-devel should provide gd-devel, but it doesn't)

* Tue Jan 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-8mdk
- rebuilt against gd2

* Wed Oct 02 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-7mdk
- updated logio patch by the author (Bojan Smojver <bojan@rexursive.com>)
- really apply the logio patch this time..., duh!

* Wed Oct 02 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-6mdk
- added experimental logio support for new apache2 mod_logio logfiles
- misc spec file fixes

* Mon Aug 26 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-5mdk
- used the following rpm woodoo magic by Ben Reser <ben@reser.org>
    - Switch to using perl to autogenerate packages
    - Language packages now require the appropriate locale
    - Use update-alternatives rather than ln in %post
    - Autogenerate language packages


* Thu Aug  8 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-4mdk
- fix requires (libintl not libintl1)

* Wed Aug  7 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-3mdk
- added P0 (w3c support)
- first attempt of providing localized versions (several sub packages)

* Mon Jul 15 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-2mdk
- BuildRequires on libpng-devel and missing libgd-devel (!); pointed
  out by Buchan Milne (thanks man!)
- misc spec file fixes
- actually "webasolve" is spelled "webazolver" (this has gone unnoticed
  since 2001-12-30..., amazing!)

* Sat Apr 20 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.10-1mdk
- new version

* Wed Apr  3 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.01.09-3mdk
- rebuild against new libz
- spec file fixes (Requires/BuildRequires)

* Sun Dec 30 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.01.09-2mdk
- make webasolver symlink to webalizer ( thx Tzafrir Cohen )

* Sun Nov 04 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.01.09-1mdk
- 2.01.09

* Fri Oct 12 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.01.06-6mdk
- rebuild against new libpng

* Thu Oct 04 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.01.06-5mdk
- fix requires db1 (Oden Eriksson)

* Tue Jul 10 2001  Lenny Cartier <lenny@mandrakesoft.com> 2.01.06-4mdk
- fixes from Guillaume Rousse <g.rousse@linux-mandrake.com> :
	- really added DNS lookup support
	- s/Copyright/License
	- BuildRequires libpng-devel libgd-devel db1-devel
	- used %config(noreplace) for cron script for pleasing rpmlint

* Tue Jan 30 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.01.06-3mdk
- used - another great - srpm from Guillaume Rousse <g.rousse@mandrake-linux.com> :
	- used noreplace for config file
	- added missing doc files
	- updated html dir to /var/www
	- used script in /etc/crontab.weekly instead of modifying /etc/crontab
	- added DNS lookup support

* Thu Dec 21 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.01.06-2mdk
- remove unused files in docdir

* Thu Dec 21 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.01.06-1mdk
- updated to  2.01.06

* Tue Sep 19 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.00.11-2mdk 
- bm
- macros

* Sun Apr 09 2000 Daouda Lo <daouda@mandrakesoft.com> 2.00.11-1mdk
- build release 2.00.11

* Thu Apr 06 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.00.08-2mdk
- packager tag

* Mon Apr 03 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.00.08-1mdk
- fix group
- bz2 archive 
- used srpm provided by Oden Eriksson <oden@kvikkjokk.com>

* Sat Mar 24 2000 Oden Eriksson <oden@kvikkjokk.com>
  [2.00-08-1]

* Mon Mar 13 2000 Peter Hanecak <hanecak@megaloman.sk>
  [2.00-06-1]

* Mon Mar 13 2000 Peter Hanecak <hanecak@megaloman.sk>
  [2.00-04-1]
- removed icon (it was GIF :)

* Mon Feb 21 2000 Peter Hanecak <hanecak@megaloman.sk>
  [1.30.05-1]

* Mon Sep 13 1999 Peter Hanecak <hanecak@megaloman.sk>
  [1.30.04-4]
  rebuild against gd-1.6.3 (now PNG images are used)

* Sun Aug 29 1999 Peter Hanecak <hanecak@megaloman.sk>
  [1.30.04-3]
  source changed to .bz2

* Fri Aug 27 1999 Henri Gomez <gomez@slib.fr>
  [1.30.04-2]
  crontab activated each Sunday at 4:01 AM (just before apache rotate its log)

* Thu Aug 26 1999 Henri Gomez <gomez@slib.fr>
  [1.30-04]
  Big rework of RPM (at least configure support)
  Adapted spec to RPM 3 naming conventions,
  Changed URL
  Added icon
  Corrected -lz
  Adapted /etc/webalizer.conf to Redhat 
  New directory usage in /home/httpd/html/usage
  Add month cron in /etc/crontab

* Fri Jan 08 1999 Simon Liddington <sjl96v@ecs.soton.ac.uk>
  [1.20-11]
  Installs manpage
  Config file installed as config

* Mon Jul 27 1998 Arne Coucheron <arneco@online.no>
  [1.20-07]

* Sun Jul 26 1998 Arne Coucheron <arneco@online.no>
  [1.12-10]

* Sun Jun 14 1998 Arne Coucheron <arneco@online.no>
  [1.12-09]

* Sun Jun 07 1998 Arne Coucheron <arneco@online.no>
  [1.12-08]

* Fri Jun 05 1998 Arne Coucheron <arneco@online.no>
  [1.00-05]

* Wed May 27 1998 Arne Coucheron <arneco@online.no>
  [1.00-04]
- using predefined %%{name} and %%{version} macros
- using %defattr macro in file list, this requires rpm 2.5 to build
- installing msfree.gif to /home/httpd/html/usage
- added -q parameter to %setup
- added CHANGES and TODO to %doc

* Fri May 08 1998 Arne Coucheron <arneco@online.no>
  [0.99.06-1]

* Sat Jan 31 1998 Arne Coucheron <arneco@online.no>
- First release
